#import "iCore.h"
#import "iSQL.h"
#import "iRandomAccessFile.h"
#import "iDebug.h"
@class b4i_main;
@class b4i_myclass;
@interface b4i_keyvaluestore : B4IClass
- (NSString*)  _class_globals:(b4i_keyvaluestore*) __ref;
@property (nonatomic)B4ISQL* _sql1;
@property (nonatomic)NSString* _tempfolder;
@property (nonatomic)NSString* _tempfile;
@property (nonatomic)b4i_main* _main;
- (NSString*)  _close:(b4i_keyvaluestore*) __ref;
- (BOOL)  _complete:(b4i_keyvaluestore*) __ref :(BOOL) _success;
- (BOOL)  _containskey:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (NSString*)  _createtable:(b4i_keyvaluestore*) __ref;
- (NSString*)  _deleteall:(b4i_keyvaluestore*) __ref;
- (B4IBitmap*)  _getbitmap:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (B4IResultSet*)  _getcursor:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (NSObject*)  _getencryptedobject:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSString*) _password;
- (B4IInputStream*)  _getinputstream:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (NSObject*)  _getobject:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (NSObject*)  _getobjectinternal:(b4i_keyvaluestore*) __ref :(NSString*) _key :(BOOL) _decrypt :(NSString*) _password;
- (NSString*)  _getsimple:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (NSString*)  _initialize:(b4i_keyvaluestore*) __ref :(B4I*) _ba :(NSString*) _dir :(NSString*) _filename;
- (NSString*)  _insertquery:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value;
- (B4IList*)  _listkeys:(b4i_keyvaluestore*) __ref;
- (BOOL)  _putbitmap:(b4i_keyvaluestore*) __ref :(NSString*) _key :(B4IBitmap*) _value;
- (BOOL)  _putinputstream:(b4i_keyvaluestore*) __ref :(NSString*) _key :(B4IInputStream*) _value;
- (BOOL)  _putobject:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value;
- (BOOL)  _putobjectinternal:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value :(BOOL) _encrypt :(NSString*) _password;
- (BOOL)  _putsimple:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value;
- (NSString*)  _remove:(b4i_keyvaluestore*) __ref :(NSString*) _key;
- (NSString*)  _start:(b4i_keyvaluestore*) __ref :(NSString*) _key;
@end
