
#import "b4i_keyvaluestore.h"
#import "b4i_main.h"
#import "b4i_myclass.h"


@implementation b4i_keyvaluestore 


+ (B4I*)createBI {
    return [B4IShellBI alloc];
}

- (void)dealloc {
    if (self.bi != nil)
        NSLog(@"Class (b4i_keyvaluestore) instance released.");
}

- (NSString*)  _initialize:(b4i_keyvaluestore*) __ref :(B4I*) _ba :(NSString*) _dir :(NSString*) _filename{
__ref = self;
[self initializeClassModule];
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Public Sub Initialize (Dir As String, FileName As";
[B4IRDebugUtils shared].currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="If sql1.IsInitialized Then sql1.Close";
if ([__ref._sql1 IsInitialized]) { 
[__ref._sql1 Close];};
[B4IRDebugUtils shared].currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="sql1.Initialize(Dir, FileName, True)";
[__ref._sql1 Initialize:_dir :_filename :[self.__c True]];
[B4IRDebugUtils shared].currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="CreateTable";
[__ref _createtable:nil];
[B4IRDebugUtils shared].currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="End Sub";
return @"";
}
- (BOOL)  _putobject:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Public Sub PutObject(Key As String, Value As Objec";
[B4IRDebugUtils shared].currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="Return putObjectInternal(Key, Value, False, \"\")";
if (true) return [__ref _putobjectinternal:nil :_key :_value :[self.__c False] :@""];
[B4IRDebugUtils shared].currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="End Sub";
return false;
}
- (BOOL)  _containskey:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Public Sub ContainsKey(Key As String) As Boolean";
[B4IRDebugUtils shared].currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="Return sql1.ExecQuerySingleResult2(\"SELECT count(";
if (true) return [self.bi ObjectToNumber:[__ref._sql1 ExecQuerySingleResult2:@"SELECT count(key) FROM main WHERE key = ?" :[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:_key]]]]]].doubleValue>0;
[B4IRDebugUtils shared].currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="End Sub";
return false;
}
- (NSObject*)  _getobject:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Public Sub GetObject(Key As String) As Object";
[B4IRDebugUtils shared].currentLine=1114113;
 //BA.debugLineNum = 1114113;BA.debugLine="Return getObjectInternal(Key, False, \"\")";
if (true) return [__ref _getobjectinternal:nil :_key :[self.__c False] :@""];
[B4IRDebugUtils shared].currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _class_globals:(b4i_keyvaluestore*) __ref{
self._main=[b4i_main new];
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Class_Globals";
return @"";
}
- (NSString*)  _close:(b4i_keyvaluestore*) __ref{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1245184;
 //BA.debugLineNum = 1245184;BA.debugLine="Public Sub Close";
[B4IRDebugUtils shared].currentLine=1245185;
 //BA.debugLineNum = 1245185;BA.debugLine="sql1.Close";
[__ref._sql1 Close];
[B4IRDebugUtils shared].currentLine=1245186;
 //BA.debugLineNum = 1245186;BA.debugLine="End Sub";
return @"";
}
- (BOOL)  _complete:(b4i_keyvaluestore*) __ref :(BOOL) _success{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1638400;
 //BA.debugLineNum = 1638400;BA.debugLine="Private Sub complete(success As Boolean) As Boolea";
[B4IRDebugUtils shared].currentLine=1638401;
 //BA.debugLineNum = 1638401;BA.debugLine="If success Then";
if (_success) { 
[B4IRDebugUtils shared].currentLine=1638402;
 //BA.debugLineNum = 1638402;BA.debugLine="sql1.TransactionSuccessful";
[__ref._sql1 TransactionSuccessful];
 }else {
[B4IRDebugUtils shared].currentLine=1638404;
 //BA.debugLineNum = 1638404;BA.debugLine="Log(\"Error saving object: \" & LastException)";
[self.__c Log:[@[@"Error saving object: ",[self.bi ObjectToString:[self.__c LastException]]] componentsJoinedByString:@""]];
[B4IRDebugUtils shared].currentLine=1638405;
 //BA.debugLineNum = 1638405;BA.debugLine="sql1.Rollback";
[__ref._sql1 Rollback];
 };
[B4IRDebugUtils shared].currentLine=1638407;
 //BA.debugLineNum = 1638407;BA.debugLine="Return success";
if (true) return _success;
[B4IRDebugUtils shared].currentLine=1638408;
 //BA.debugLineNum = 1638408;BA.debugLine="End Sub";
return false;
}
- (NSString*)  _createtable:(b4i_keyvaluestore*) __ref{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1507328;
 //BA.debugLineNum = 1507328;BA.debugLine="Private Sub CreateTable";
[B4IRDebugUtils shared].currentLine=1507329;
 //BA.debugLineNum = 1507329;BA.debugLine="sql1.ExecNonQuery(\"CREATE TABLE IF NOT EXISTS mai";
[__ref._sql1 ExecNonQuery:@"CREATE TABLE IF NOT EXISTS main(key TEXT PRIMARY KEY, value NONE)"];
[B4IRDebugUtils shared].currentLine=1507330;
 //BA.debugLineNum = 1507330;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _deleteall:(b4i_keyvaluestore*) __ref{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Public Sub DeleteAll";
[B4IRDebugUtils shared].currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="sql1.ExecNonQuery(\"DROP TABLE main\")";
[__ref._sql1 ExecNonQuery:@"DROP TABLE main"];
[B4IRDebugUtils shared].currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="CreateTable";
[__ref _createtable:nil];
[B4IRDebugUtils shared].currentLine=851971;
 //BA.debugLineNum = 851971;BA.debugLine="End Sub";
return @"";
}
- (B4IBitmap*)  _getbitmap:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IResultSet* _c = nil;
B4IBitmap* _b = nil;
B4IArray* _buffer = nil;
B4IInputStream* _in = nil;
[B4IRDebugUtils shared].currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Public Sub GetBitmap(Key As String) As Bitmap";
[B4IRDebugUtils shared].currentLine=1048577;
 //BA.debugLineNum = 1048577;BA.debugLine="Dim c As ResultSet = getCursor(Key)";
_c = [__ref _getcursor:nil :_key];
[B4IRDebugUtils shared].currentLine=1048578;
 //BA.debugLineNum = 1048578;BA.debugLine="Dim b As Bitmap";
_b = [B4IBitmap new];
[B4IRDebugUtils shared].currentLine=1048579;
 //BA.debugLineNum = 1048579;BA.debugLine="If c.NextRow = False Then";
if ([_c NextRow]==[self.__c False]) { 
[B4IRDebugUtils shared].currentLine=1048580;
 //BA.debugLineNum = 1048580;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=1048581;
 //BA.debugLineNum = 1048581;BA.debugLine="Return b";
if (true) return _b;
 };
[B4IRDebugUtils shared].currentLine=1048583;
 //BA.debugLineNum = 1048583;BA.debugLine="Dim buffer() As Byte = c.GetBlob2(0)";
_buffer = [_c GetBlob2:(int) (0)];
[B4IRDebugUtils shared].currentLine=1048584;
 //BA.debugLineNum = 1048584;BA.debugLine="Dim In As InputStream";
_in = [B4IInputStream new];
[B4IRDebugUtils shared].currentLine=1048585;
 //BA.debugLineNum = 1048585;BA.debugLine="In.InitializeFromBytesArray(buffer, 0, buffer.Len";
[_in InitializeFromBytesArray:_buffer :(int) (0) :_buffer.Length];
[B4IRDebugUtils shared].currentLine=1048586;
 //BA.debugLineNum = 1048586;BA.debugLine="b.Initialize2(In)";
[_b Initialize2:_in];
[B4IRDebugUtils shared].currentLine=1048587;
 //BA.debugLineNum = 1048587;BA.debugLine="In.Close";
[_in Close];
[B4IRDebugUtils shared].currentLine=1048588;
 //BA.debugLineNum = 1048588;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=1048589;
 //BA.debugLineNum = 1048589;BA.debugLine="Return b";
if (true) return _b;
[B4IRDebugUtils shared].currentLine=1048590;
 //BA.debugLineNum = 1048590;BA.debugLine="End Sub";
return nil;
}
- (B4IResultSet*)  _getcursor:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1376256;
 //BA.debugLineNum = 1376256;BA.debugLine="Private Sub getCursor(Key As String) As ResultSet";
[B4IRDebugUtils shared].currentLine=1376257;
 //BA.debugLineNum = 1376257;BA.debugLine="Return sql1.ExecQuery2(\"SELECT value FROM main WH";
if (true) return [__ref._sql1 ExecQuery2:@"SELECT value FROM main WHERE key = ?" :[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:_key]]]]];
[B4IRDebugUtils shared].currentLine=1376258;
 //BA.debugLineNum = 1376258;BA.debugLine="End Sub";
return nil;
}
- (NSObject*)  _getencryptedobject:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSString*) _password{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1179648;
 //BA.debugLineNum = 1179648;BA.debugLine="Public Sub GetEncryptedObject(Key As String, Passw";
[B4IRDebugUtils shared].currentLine=1179649;
 //BA.debugLineNum = 1179649;BA.debugLine="Return getObjectInternal(Key, True, Password)";
if (true) return [__ref _getobjectinternal:nil :_key :[self.__c True] :_password];
[B4IRDebugUtils shared].currentLine=1179650;
 //BA.debugLineNum = 1179650;BA.debugLine="End Sub";
return nil;
}
- (NSObject*)  _getobjectinternal:(b4i_keyvaluestore*) __ref :(NSString*) _key :(BOOL) _decrypt :(NSString*) _password{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IResultSet* _c = nil;
B4IArray* _buffer = nil;
B4IRandomAccessFile* _raf = nil;
NSObject* _res = nil;
[B4IRDebugUtils shared].currentLine=1310720;
 //BA.debugLineNum = 1310720;BA.debugLine="Private Sub getObjectInternal(Key As String, decry";
[B4IRDebugUtils shared].currentLine=1310721;
 //BA.debugLineNum = 1310721;BA.debugLine="Dim c As ResultSet = getCursor(Key)";
_c = [__ref _getcursor:nil :_key];
[B4IRDebugUtils shared].currentLine=1310722;
 //BA.debugLineNum = 1310722;BA.debugLine="If c.NextRow = False Then";
if ([_c NextRow]==[self.__c False]) { 
[B4IRDebugUtils shared].currentLine=1310723;
 //BA.debugLineNum = 1310723;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=1310724;
 //BA.debugLineNum = 1310724;BA.debugLine="Return Null";
if (true) return [self.__c Null];
 };
[B4IRDebugUtils shared].currentLine=1310726;
 //BA.debugLineNum = 1310726;BA.debugLine="Dim buffer() As Byte = c.GetBlob2(0)";
_buffer = [_c GetBlob2:(int) (0)];
[B4IRDebugUtils shared].currentLine=1310727;
 //BA.debugLineNum = 1310727;BA.debugLine="Dim raf As RandomAccessFile";
_raf = [B4IRandomAccessFile new];
[B4IRDebugUtils shared].currentLine=1310728;
 //BA.debugLineNum = 1310728;BA.debugLine="raf.Initialize3(buffer, False)";
[_raf Initialize3:_buffer :[self.__c False]];
[B4IRDebugUtils shared].currentLine=1310729;
 //BA.debugLineNum = 1310729;BA.debugLine="Dim res As Object";
_res = [NSObject new];
[B4IRDebugUtils shared].currentLine=1310730;
 //BA.debugLineNum = 1310730;BA.debugLine="If decrypt Then";
if (_decrypt) { 
[B4IRDebugUtils shared].currentLine=1310731;
 //BA.debugLineNum = 1310731;BA.debugLine="Log(\"Not supported.\")";
[self.__c Log:@"Not supported."];
 }else {
[B4IRDebugUtils shared].currentLine=1310734;
 //BA.debugLineNum = 1310734;BA.debugLine="res = raf.ReadB4XObject(raf.CurrentPosition)";
_res = [_raf ReadB4XObject:[_raf CurrentPosition]];
 };
[B4IRDebugUtils shared].currentLine=1310736;
 //BA.debugLineNum = 1310736;BA.debugLine="raf.Close";
[_raf Close];
[B4IRDebugUtils shared].currentLine=1310737;
 //BA.debugLineNum = 1310737;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=1310738;
 //BA.debugLineNum = 1310738;BA.debugLine="Return res";
if (true) return _res;
[B4IRDebugUtils shared].currentLine=1310739;
 //BA.debugLineNum = 1310739;BA.debugLine="End Sub";
return nil;
}
- (B4IInputStream*)  _getinputstream:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IResultSet* _c = nil;
B4IArray* _buffer = nil;
B4IInputStream* _in = nil;
[B4IRDebugUtils shared].currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Public Sub GetInputStream(Key As String) As InputS";
[B4IRDebugUtils shared].currentLine=983041;
 //BA.debugLineNum = 983041;BA.debugLine="Dim c As ResultSet = getCursor(Key)";
_c = [__ref _getcursor:nil :_key];
[B4IRDebugUtils shared].currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="If c.NextRow = False Then";
if ([_c NextRow]==[self.__c False]) { 
[B4IRDebugUtils shared].currentLine=983043;
 //BA.debugLineNum = 983043;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=983044;
 //BA.debugLineNum = 983044;BA.debugLine="Return Null";
if (true) return (B4IInputStream*) [B4IObjectWrapper createWrapper:[B4IInputStream new] object:(NSInputStream*)([self.__c Null])];
 };
[B4IRDebugUtils shared].currentLine=983046;
 //BA.debugLineNum = 983046;BA.debugLine="Dim buffer() As Byte = c.GetBlob2(0)";
_buffer = [_c GetBlob2:(int) (0)];
[B4IRDebugUtils shared].currentLine=983047;
 //BA.debugLineNum = 983047;BA.debugLine="Dim In As InputStream";
_in = [B4IInputStream new];
[B4IRDebugUtils shared].currentLine=983048;
 //BA.debugLineNum = 983048;BA.debugLine="In.InitializeFromBytesArray(buffer, 0, buffer.Len";
[_in InitializeFromBytesArray:_buffer :(int) (0) :_buffer.Length];
[B4IRDebugUtils shared].currentLine=983049;
 //BA.debugLineNum = 983049;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=983050;
 //BA.debugLineNum = 983050;BA.debugLine="Return In";
if (true) return _in;
[B4IRDebugUtils shared].currentLine=983051;
 //BA.debugLineNum = 983051;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _getsimple:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IResultSet* _c = nil;
NSString* _res = @"";
[B4IRDebugUtils shared].currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Public Sub GetSimple(Key As String) As String";
[B4IRDebugUtils shared].currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="Dim c As ResultSet = getCursor(Key)";
_c = [__ref _getcursor:nil :_key];
[B4IRDebugUtils shared].currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="If c.NextRow = False Then";
if ([_c NextRow]==[self.__c False]) { 
[B4IRDebugUtils shared].currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=917508;
 //BA.debugLineNum = 917508;BA.debugLine="Return \"\"";
if (true) return @"";
 };
[B4IRDebugUtils shared].currentLine=917510;
 //BA.debugLineNum = 917510;BA.debugLine="Dim res As String = c.GetString2(0)";
_res = [_c GetString2:(int) (0)];
[B4IRDebugUtils shared].currentLine=917511;
 //BA.debugLineNum = 917511;BA.debugLine="c.Close";
[_c Close];
[B4IRDebugUtils shared].currentLine=917512;
 //BA.debugLineNum = 917512;BA.debugLine="Return res";
if (true) return _res;
[B4IRDebugUtils shared].currentLine=917513;
 //BA.debugLineNum = 917513;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _insertquery:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1441792;
 //BA.debugLineNum = 1441792;BA.debugLine="Private Sub insertQuery(Key As String, Value As Ob";
[B4IRDebugUtils shared].currentLine=1441793;
 //BA.debugLineNum = 1441793;BA.debugLine="sql1.ExecNonQuery2(\"INSERT INTO main VALUES(?, ?)";
[__ref._sql1 ExecNonQuery2:@"INSERT INTO main VALUES(?, ?)" :[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(_key)],[B4I nilToNSNull:_value]]]]];
[B4IRDebugUtils shared].currentLine=1441794;
 //BA.debugLineNum = 1441794;BA.debugLine="End Sub";
return @"";
}
- (B4IList*)  _listkeys:(b4i_keyvaluestore*) __ref{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IResultSet* _c = nil;
B4IList* _res = nil;
[B4IRDebugUtils shared].currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Public Sub ListKeys As List";
[B4IRDebugUtils shared].currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="Dim c As ResultSet= sql1.ExecQuery(\"SELECT key FR";
_c = [__ref._sql1 ExecQuery:@"SELECT key FROM main"];
[B4IRDebugUtils shared].currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="Dim res As List";
_res = [B4IList new];
[B4IRDebugUtils shared].currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="res.Initialize";
[_res Initialize];
[B4IRDebugUtils shared].currentLine=720900;
 //BA.debugLineNum = 720900;BA.debugLine="Do While c.NextRow";
while ([_c NextRow]) {
[B4IRDebugUtils shared].currentLine=720901;
 //BA.debugLineNum = 720901;BA.debugLine="res.Add(c.GetString2(0))";
[_res Add:(NSObject*)([_c GetString2:(int) (0)])];
 }
;
[B4IRDebugUtils shared].currentLine=720903;
 //BA.debugLineNum = 720903;BA.debugLine="Return res";
if (true) return _res;
[B4IRDebugUtils shared].currentLine=720904;
 //BA.debugLineNum = 720904;BA.debugLine="End Sub";
return nil;
}
- (BOOL)  _putbitmap:(b4i_keyvaluestore*) __ref :(NSString*) _key :(B4IBitmap*) _value{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IOutputStream* _out = nil;
B4IBitmap* _b = nil;
[B4IRDebugUtils shared].currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Public Sub PutBitmap(Key As String, Value As Bitma";
[B4IRDebugUtils shared].currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="Try";
@try {[B4IRDebugUtils shared].currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="start(Key)";
[__ref _start:nil :_key];
[B4IRDebugUtils shared].currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="Dim out As OutputStream";
_out = [B4IOutputStream new];
[B4IRDebugUtils shared].currentLine=524292;
 //BA.debugLineNum = 524292;BA.debugLine="out.InitializeToBytesArray(100)";
[_out InitializeToBytesArray:(int) (100)];
[B4IRDebugUtils shared].currentLine=524293;
 //BA.debugLineNum = 524293;BA.debugLine="Dim b As Bitmap = Value";
_b = [B4IBitmap new];
_b = _value;
[B4IRDebugUtils shared].currentLine=524294;
 //BA.debugLineNum = 524294;BA.debugLine="b.WriteToStream(out, 100, \"PNG\")";
[_b WriteToStream:_out :(int) (100) :@"PNG"];
[B4IRDebugUtils shared].currentLine=524295;
 //BA.debugLineNum = 524295;BA.debugLine="insertQuery(Key, out.ToBytesArray)";
[__ref _insertquery:nil :_key :(NSObject*)([_out ToBytesArray])];
[B4IRDebugUtils shared].currentLine=524296;
 //BA.debugLineNum = 524296;BA.debugLine="out.Close";
[_out Close];
[B4IRDebugUtils shared].currentLine=524297;
 //BA.debugLineNum = 524297;BA.debugLine="Return complete(True)";
if (true) return [__ref _complete:nil :[self.__c True]];
 } 
       @catch (NSException* e32) {
			[B4I SetException:e32];[B4IRDebugUtils shared].currentLine=524299;
 //BA.debugLineNum = 524299;BA.debugLine="Return complete(False)";
if (true) return [__ref _complete:nil :[self.__c False]];
 };
[B4IRDebugUtils shared].currentLine=524301;
 //BA.debugLineNum = 524301;BA.debugLine="End Sub";
return false;
}
- (NSString*)  _start:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=1572864;
 //BA.debugLineNum = 1572864;BA.debugLine="Private Sub start (Key As String)";
[B4IRDebugUtils shared].currentLine=1572865;
 //BA.debugLineNum = 1572865;BA.debugLine="sql1.BeginTransaction";
[__ref._sql1 BeginTransaction];
[B4IRDebugUtils shared].currentLine=1572866;
 //BA.debugLineNum = 1572866;BA.debugLine="sql1.ExecNonQuery2(\"DELETE FROM main WHERE key =";
[__ref._sql1 ExecNonQuery2:@"DELETE FROM main WHERE key = ?" :[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(_key)]]]]];
[B4IRDebugUtils shared].currentLine=1572867;
 //BA.debugLineNum = 1572867;BA.debugLine="End Sub";
return @"";
}
- (BOOL)  _putinputstream:(b4i_keyvaluestore*) __ref :(NSString*) _key :(B4IInputStream*) _value{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IOutputStream* _out = nil;
[B4IRDebugUtils shared].currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Public Sub PutInputStream(Key As String, Value As";
[B4IRDebugUtils shared].currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="Try";
@try {[B4IRDebugUtils shared].currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="start(Key)";
[__ref _start:nil :_key];
[B4IRDebugUtils shared].currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="Dim out As OutputStream";
_out = [B4IOutputStream new];
[B4IRDebugUtils shared].currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="out.InitializeToBytesArray(100)";
[_out InitializeToBytesArray:(int) (100)];
[B4IRDebugUtils shared].currentLine=589829;
 //BA.debugLineNum = 589829;BA.debugLine="File.Copy2(Value, out)";
[[self.__c File] Copy2:_value :_out];
[B4IRDebugUtils shared].currentLine=589830;
 //BA.debugLineNum = 589830;BA.debugLine="Value.Close";
[_value Close];
[B4IRDebugUtils shared].currentLine=589831;
 //BA.debugLineNum = 589831;BA.debugLine="insertQuery(Key, out.ToBytesArray)";
[__ref _insertquery:nil :_key :(NSObject*)([_out ToBytesArray])];
[B4IRDebugUtils shared].currentLine=589832;
 //BA.debugLineNum = 589832;BA.debugLine="out.Close";
[_out Close];
[B4IRDebugUtils shared].currentLine=589833;
 //BA.debugLineNum = 589833;BA.debugLine="Return complete(True)";
if (true) return [__ref _complete:nil :[self.__c True]];
 } 
       @catch (NSException* e46) {
			[B4I SetException:e46];[B4IRDebugUtils shared].currentLine=589835;
 //BA.debugLineNum = 589835;BA.debugLine="Return complete(False)";
if (true) return [__ref _complete:nil :[self.__c False]];
 };
[B4IRDebugUtils shared].currentLine=589837;
 //BA.debugLineNum = 589837;BA.debugLine="End Sub";
return false;
}
- (BOOL)  _putobjectinternal:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value :(BOOL) _encrypt :(NSString*) _password{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
B4IRandomAccessFile* _raf = nil;
B4IArray* _buffer = nil;
[B4IRDebugUtils shared].currentLine=1703936;
 //BA.debugLineNum = 1703936;BA.debugLine="Private Sub putObjectInternal(Key As String, Value";
[B4IRDebugUtils shared].currentLine=1703937;
 //BA.debugLineNum = 1703937;BA.debugLine="Try";
@try {[B4IRDebugUtils shared].currentLine=1703938;
 //BA.debugLineNum = 1703938;BA.debugLine="start(Key)";
[__ref _start:nil :_key];
[B4IRDebugUtils shared].currentLine=1703939;
 //BA.debugLineNum = 1703939;BA.debugLine="Dim raf As RandomAccessFile";
_raf = [B4IRandomAccessFile new];
[B4IRDebugUtils shared].currentLine=1703940;
 //BA.debugLineNum = 1703940;BA.debugLine="File.Delete(tempFolder, tempFile)";
[[self.__c File] Delete:__ref._tempfolder :__ref._tempfile];
[B4IRDebugUtils shared].currentLine=1703941;
 //BA.debugLineNum = 1703941;BA.debugLine="raf.Initialize(tempFolder, tempFile, False)";
[_raf Initialize:__ref._tempfolder :__ref._tempfile :[self.__c False]];
[B4IRDebugUtils shared].currentLine=1703942;
 //BA.debugLineNum = 1703942;BA.debugLine="If encrypt Then";
if (_encrypt) { 
[B4IRDebugUtils shared].currentLine=1703943;
 //BA.debugLineNum = 1703943;BA.debugLine="Log(\"Not supported\")";
[self.__c Log:@"Not supported"];
 }else {
[B4IRDebugUtils shared].currentLine=1703945;
 //BA.debugLineNum = 1703945;BA.debugLine="raf.WriteB4XObject(Value, raf.CurrentPosition)";
[_raf WriteB4XObject:_value :[_raf CurrentPosition]];
 };
[B4IRDebugUtils shared].currentLine=1703947;
 //BA.debugLineNum = 1703947;BA.debugLine="raf.Flush";
[_raf Flush];
[B4IRDebugUtils shared].currentLine=1703948;
 //BA.debugLineNum = 1703948;BA.debugLine="Dim buffer(raf.CurrentPosition) As Byte";
_buffer = [[B4IArray alloc]initBytes:@[@((int) ([_raf CurrentPosition]))]];
[B4IRDebugUtils shared].currentLine=1703949;
 //BA.debugLineNum = 1703949;BA.debugLine="raf.ReadBytes(buffer, 0, buffer.Length, 0)";
[_raf ReadBytes:_buffer :(int) (0) :_buffer.Length :(long long) (0)];
[B4IRDebugUtils shared].currentLine=1703950;
 //BA.debugLineNum = 1703950;BA.debugLine="raf.Close";
[_raf Close];
[B4IRDebugUtils shared].currentLine=1703951;
 //BA.debugLineNum = 1703951;BA.debugLine="insertQuery(Key, buffer)";
[__ref _insertquery:nil :_key :(NSObject*)(_buffer)];
[B4IRDebugUtils shared].currentLine=1703952;
 //BA.debugLineNum = 1703952;BA.debugLine="Return complete(True)";
if (true) return [__ref _complete:nil :[self.__c True]];
 } 
       @catch (NSException* e173) {
			[B4I SetException:e173];[B4IRDebugUtils shared].currentLine=1703954;
 //BA.debugLineNum = 1703954;BA.debugLine="Return complete(False)";
if (true) return [__ref _complete:nil :[self.__c False]];
 };
[B4IRDebugUtils shared].currentLine=1703956;
 //BA.debugLineNum = 1703956;BA.debugLine="End Sub";
return false;
}
- (BOOL)  _putsimple:(b4i_keyvaluestore*) __ref :(NSString*) _key :(NSObject*) _value{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Public Sub PutSimple(Key As String, Value As Objec";
[B4IRDebugUtils shared].currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Try";
@try {[B4IRDebugUtils shared].currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="start(Key)";
[__ref _start:nil :_key];
[B4IRDebugUtils shared].currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="insertQuery(Key, Value)";
[__ref _insertquery:nil :_key :_value];
[B4IRDebugUtils shared].currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="Return complete(True)";
if (true) return [__ref _complete:nil :[self.__c True]];
 } 
       @catch (NSException* e15) {
			[B4I SetException:e15];[B4IRDebugUtils shared].currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="Return complete(False)";
if (true) return [__ref _complete:nil :[self.__c False]];
 };
[B4IRDebugUtils shared].currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="End Sub";
return false;
}
- (NSString*)  _remove:(b4i_keyvaluestore*) __ref :(NSString*) _key{
__ref = self;
[B4IRDebugUtils shared].currentModule=@"keyvaluestore";
[B4IRDebugUtils shared].currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Public Sub Remove(Key As String)";
[B4IRDebugUtils shared].currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="sql1.ExecNonQuery2(\"DELETE FROM main WHERE key =";
[__ref._sql1 ExecNonQuery2:@"DELETE FROM main WHERE key = ?" :[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(_key)]]]]];
[B4IRDebugUtils shared].currentLine=655362;
 //BA.debugLineNum = 655362;BA.debugLine="End Sub";
return @"";
}
@end